最长上升子序列(LIS) dp学习~3

题目连接:http://acm.hdu.edu.cn/showproblem.php?pid=1087

Super Jumping! Jumping! Jumping!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 30228    Accepted Submission(s): 13530


Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
 

 

Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N 
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 

 

Output
For each case, print the maximum according to rules, and one line one case.
 

 

Sample Input
3 1 3 2 4 1 2 3 4 4 3 3 2 1 0
 

 

Sample Output
4 10 3
 

 

Author
lcy
 

 题意:求递增段最大和 

题解:类似于最长上升子序列求法,dp[i]表示,到i结尾的最大值,这道题要注意的问题是要设置一个max值保存每个点dp的最大值作为最后结果

if(mp[j]<mp[i])
dp[i] = max(dp[i],dp[j]+mp[i]);

代码;

 1 #include<cstdio>
 2 #include<algorithm>
 3 #include<cstring>
 4 using namespace std;
 5 const int N = 1005;
 6 int mp[N];
 7 int dp[N];
 8 int main()
 9 {
10     int n;
11     while(~scanf("%d",&n))
12     {
13         if(n==0) return 0;
14         for(int i = 0; i < n; i++)
15         {
16             scanf("%d",&mp[i]);
17             dp[i] = mp[i];
18         }
19         int sum = 0;
20         for(int i = 0; i < n; i++)
21         {
22             for(int j = 0; j < i; j++)
23             {
24                 if(mp[j]<mp[i])
25                     dp[i] = max(dp[i],dp[j]+mp[i]);
26                 //else dp[i] = max(dp[i],dp[j]);这么写是错误的因为遍历后面的点的时候仍会用到这个点的值。
27             }
28             sum = max(sum,dp[i]);
29         }
30         printf("%d\n",sum);
31     }
32     return 0;
33 }

 

posted on 2016-03-01 08:30  若流芳千古  阅读(223)  评论(0编辑  收藏  举报

导航